<?php
/**
* @version      $Id: admin_payment_method_editor.php
* @package      Easyshop
* @copyright    Copyright (C) 2005 - 2011 TA-EDV
* @license      proprietary
* @author       Richard Kammermayer <rk@ta-edv.de>
* Easyshop is a web shop system
*/

include_once './core/payment_method.class.php';
include_once './modules/list_and_edit.class.php';

class admin_payment_method_editor {
	private $base_object;
	private $config;
	
	function __construct($base_object, $layout_object) {
		$this->base_object = $base_object;
		$this->config = $base_object->config;
		$this->layout_object = $layout_object;
		$this->list_object = new ListAndEdit($base_object, $layout_object);
	}

	function run() {
		//$this->setup_info();

		//var_dump($GLOBALS);
		
		if(isset($_GET['id']) && $_GET['id']) {
			$has_id = true;
		} else if(isset($_POST['id']) && $_POST['id']) {
			$has_id = true;
		} else {
			$has_id = false;
		}
		
		if(isset($_POST['submit'])) {
			$is_submitted = true;
		} else {
			$is_submitted = false;
		}
	
		// decide what CRUD method to call and call it in ListAndEdit
		// create
		$payment_method_object = new Payment_method($this->base_object);
		if($is_submitted && !$has_id) {
			$form_data = $payment_method_object->data_filter($_POST['form_field']);
			if (isset($form_data['active'])) {
				$form_data['active'] = '1';
			} else {
				$form_data['active'] = '0';
			}
			$payment_method_object->create($form_data);
			$payment_method_data = $payment_method_object->get_data();
			$this->layout_object->assign('form_data', $payment_method_data);
			
			// configuration data
			if ($payment_method_data->configuration_group_id) {
				$config_data = $this->config->get_config_elements($payment_method_data->configuration_group_id);
				$this->layout_object->assign('config_data', $config_data);
			}
		}// read
		elseif($has_id && !$is_submitted && $_GET['mod'] != 'delete') {
			// template variable name
			$payment_method_object->id = $_GET['id'];
			$payment_method_data = $payment_method_object->get_data();
			$this->layout_object->assign('form_data', $payment_method_data);
			
			// configuration data
			if ($payment_method_data->configuration_group_id) {
				$config_data = $this->config->get_config_elements($payment_method_data->configuration_group_id);
				$this->layout_object->assign('config_data', $config_data);
			}
		} // update
		elseif($has_id && $is_submitted && $_GET['mod'] != 'delete') {
			$payment_method_object->id = $_POST['id'];
			$form_data = $payment_method_object->data_filter($_POST['form_field']);
			if (isset($form_data['active'])) {
				$form_data['active'] = '1';
			} else {
				$form_data['active'] = '0';
			}
			$payment_method_object->update($form_data);
			
			// payment method data
			$payment_method_data = $payment_method_object->get_data();
			$this->layout_object->assign('form_data', $payment_method_data);
			
			// configuration data
			if ($payment_method_data->configuration_group_id) {
				$config_data = $this->config->get_config_elements($payment_method_data->configuration_group_id);
				$this->layout_object->assign('config_data', $config_data);
			}
		} // delete
		elseif($has_id && isset($_GET['mod']) && $_GET['mod'] == 'delete'){
			$payment_method_object->id = $_GET['id'];
			$payment_method_object->delete();
		}
		else {

		}

		return $this->layout_object->fetch('admin_payment_method_editor.tpl');
	}
	
	
}

?>